;----------------------INTEDRATION Module-----------------------------------------------	


	in	R16,TCNT1L		;Load	to R16 low byte (RL) of digit from TC1
	in	R17,TCNT1H		;Load	to R17 high byte of digit from TC1
	lds	r18,TC1			;Load	to R18 high byte (RH) of real digit

	lds	r19,pointer		;Load	to R19 POINTER

	ldi	XL,low(BUFFER)		;
	ldi	XH,high(BUFFER)	;Adress of BUFFER to X

	ldi	YL,low(BUFFER)		;
	ldi	YH,high(BUFFER)	;Adress of BUFFER to Y

	cpi	r19,0x00		;Compare r19=0
	breq	DO11			;If ZERO GOTO DO11

	mov	r20,r19			;R19=>R20
	clr	r21			;Clear Register

DO12:	inc	r21			;
	inc	r21			;
	inc	r21			;(R21)+3
	dec	r19			;DEC R19
	brne	DO12			;If not ZERO goto DO12 
	mov	r19,r21			;R21=>R19

DO11:	add	XL,r19			;
	ldi	r23,0x00		;
	adc	XH,r23			;Set needed BUFFER position

	ld	r20,X+			;                        (RL)
	ld	r21,X+			;
	ld	r22,X+			;Previous digit loading  (RH)

	sub	r20,r16			;
	sbc	r21,r17			;		
	sbc	r22,r18			;Substraction [BUFFER(i-1)-BUFFER(i)]	
	
	ldi	r23,0x04		;Load to R23 POROG=3 |
	add	r20,r23			;                    |
	clr	r23			;Load to R23 0x00    |
	adc	r21,r23			;                    |
	adc	r22,r23			;                    |[BUFFER(i-1)-BUFFER(i)]+[POROG=3]	

	cpi	r20,0x06		;Compare Result with 2*POROG=6
	brlo	DO6			;If LOWER then 2*POROG=6 goto DO6

	ldi	r23,10			;Counter=10

DO7:	st	Y+,R16			;	
	st	Y+,R17			;
	st	Y+,R18			;Store DIGIT to RAM with post adr INC
	dec	r23			;Counter=Counter-1
	brne	DO7			;If not ZERO goto DO7

DO6:	lds	r19,pointer		;Load	to R19 POINTER
	inc	R19			;Inc POINTER
	cpi	r19,0x10		;Compare POINTER with 10
	brne	DO8			;IF not ZERO goto DO8
	clr	r19			;POINTER=0

DO8:	sts	pointer,r19		;Store POINTER in RAM

	st	X+,r16			;
	st	X+,r17			;
	st	X,r18			;Store new digit in RAM

	ldi	r23,9			;Counter=9

	ldi	YL,low(BUFFER)		;
	ldi	YH,high(BUFFER)	;Adress of BUFFER to Y
	
	ld	r20,Y+			;               (RL)
	ld	r21,Y+			;
	ld	r22,Y+			;Digit loading  (RH)

DO9:	ld	r16,Y+			;               (RL)
	ld	r17,Y+			;
	ld	r18,Y+			;Digit loading  (RH)

	add	r20,r16			;
	adc	r21,r17			;
	adc	r22,r18			;Summorizing

	dec	r23			;Counter=Counter-1
	brne	DO9			;If not ZERO goto DO7


	sts	DIGIT_BIN,R20		;
	sts	DIGIT_BIN+1,R21	;
	sts	DIGIT_BIN+2,R22	;
	clr	r16			;
	sts	DIGIT_BIN+3,r16	;Reconstructered digit to RAM for needed decoding

;------------------------ END -----------------------------------------------	