
DEC_2_7SEG:	push	r16		;Push R16 to stack
		push	ZL		;Push ZL to stack
		push	XL		;Push XL to stack	
		push	YL		;Push YL to stack
		push 	r0			;Push r0 to stack
		push 	r17		;Push r17 to stack
		push 	r18		;Push r18 to stack
		push 	r19		;


		ldi	r16,8		;Counter=0...8
		ldi	ZL,DIGITS*2	;First adress of digits codes
		ldi	XL,DIGIT_7SEG	;First adress of digit in 7SEG code
		ldi	YL,DIGIT_DEC	;First adress of digit in DEC code

DEC1:		ld	r17,Y+		;Load to r17 DEC digit whith post adr INCR 
		add	ZL,r17		;Get new adr for DIGITS offset
		LPM			;LPM from ZL to R0

		mov	R18,R0

		tst	LOGO
		brne	DEC2

		cp	r16,PNT		;Compare counter & PNT	
		in	r19,SREG	;Load SREG
		sbrc	r19,1		;If COUNTER<>6 then jump over next line	
		ori	R18,0b00000100	;Set point		

		rjmp	DEC3

DEC2:		cpi	r16,7		;Compare counter & 6		
		in	r19,SREG	;Load SREG
		sbrc	r19,1		;If COUNTER<>6 then jump over next line
		ori	R18,0b00000100	;Set point


		cpi	r16,4		;Compare counter & 2		
		in	r19,SREG	;Load SREG
		sbrc	r19,1		;If COUNTER<>2 then jump over next line
		ori	R18,0b00000100	;Set point

DEC3:		mov	R0,R18

		st	X+,R0		;Store digit in 7SEG code with post adr INCR
		dec	r16		;Decrement counter
		ldi	ZL,DIGITS*2	;Recover First adress of digits codes
		brne	DEC1		;If counter not 0 goto DEC1

		pop 	r19		;
		pop 	r18		;Pop R17 from stack
		pop 	r17		;Pop R17 from stack
		pop 	r0		;Pop r0 from stack
		pop 	YL		;Pop YL from stack
		pop 	XL		;Pop XL from stack
		pop 	ZL		;Pop ZL from stack
		pop 	r16		;Pop R16 from stack

		RET